/* $Id: NamedObjectHasInvalidName.java 210 2004-06-26 16:25:03Z pmoor $ */
package org.jopera.demo.verifier;

import org.eclipse.core.resources.IMarker;

import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IMarkerResolution;
import org.eclipse.ui.IMarkerResolution2;

import ch.ethz.jopera.core.model.NamedObject;
import ch.ethz.jopera.core.model.errors.JOperaError;


/**
 * @author pmoor
 */
public class SampleError extends JOperaError {

	public SampleError(String name) {
		setMessage(name+" has an invalid name!");
		setHasResolution(true);
	}
	
	public IMarkerResolution[] getResolutions() {
		final NamedObject obj = (NamedObject)getSource();
		IMarkerResolution[] res = new IMarkerResolution[1];
		res[0] = new IMarkerResolution2() {
			public String getDescription() {
				return "Correct the name";
			}
			public String getLabel() {
				return "Rename to \""+calcNewName(obj.getName())+"\"";
			}
			public void run(IMarker marker) {
				obj.setName(calcNewName(obj.getName()));
			}
			public Image getImage() { return null; }
		};
		return res;
	}
	
	String calcNewName(String oldname) {
		String newname = "";
		for ( int i=0; i<oldname.length(); i++ ) {
			char c = oldname.charAt(i);
			if ( Character.isJavaIdentifierPart(c) ) {
				newname += c;
			}
		}
		if ( newname.length() == 0 ) {
			newname = "anonymous";
		}
		return newname;
	}
}
