package org.jopera.demo.verifier;

import ch.ethz.jopera.compiler.verifier.IModelVerifier;
import ch.ethz.jopera.core.model.AbstractParameter;
import ch.ethz.jopera.core.model.AccessMethod;
import ch.ethz.jopera.core.model.Arrow;
import ch.ethz.jopera.core.model.Binding;
import ch.ethz.jopera.core.model.ComponentType;
import ch.ethz.jopera.core.model.ModelObject;
import ch.ethz.jopera.core.model.NamedObject;
import ch.ethz.jopera.core.model.Process;
import ch.ethz.jopera.core.model.Program;
import ch.ethz.jopera.core.model.RefBox;
import ch.ethz.jopera.core.model.Task;
import ch.ethz.jopera.core.model.View;

public class SampleModelVerifier implements IModelVerifier {

	public SampleModelVerifier() {
		// TODO Auto-generated constructor stub
	}

	public void verify(ModelObject object) {
		
		verifyDescription(object);
		
		//do type-specific verification
		if ( object instanceof Process ) {
    		verifyProcess((Process)object);
    	} else if ( object instanceof Task ) {
    		verifyTask((Task)object);
    	} else if ( object instanceof AccessMethod ) {
    		verifyAccessMethod((AccessMethod)object);
    	} else if ( object instanceof ComponentType ) {
    		verifyComponentType((ComponentType)object);
    	} else if ( object instanceof AbstractParameter ) {
    		verifyParameter((AbstractParameter)object);
    	} else if ( object instanceof Program ) {
    		verifyProgram((Program)object);
    	} else if ( object instanceof View ) {
    		verifyView((View)object);
    	} else if ( object instanceof Binding ) {
    		verifyBinding((Binding)object);
    	} else if ( object instanceof Arrow ) {
    		_verifyArrow((Arrow)object);
    	} else if ( object instanceof RefBox ) {
    		_verifyRefBox((RefBox)object);
    	}
		
	}

	private void verifyDescription(ModelObject object) {
		
		if (object instanceof NamedObject) {
			NamedObject n = (NamedObject)object;
			
			//check the model object for some property
			if (n.getDescription() == null || n.getDescription().length() == 0) {
				//if there is a problem attach a marker to the object
				n.addOwnProblem(new SampleWarning(n.getName()));
			} else {
				//if there is no problem then make sure the object does not have any marker attached
				n.removeOwnProblemType(SampleWarning.class);
			}
		}
		
	}

	private void _verifyRefBox(RefBox object) {
		// TODO Auto-generated method stub
		
	}

	private void _verifyArrow(Arrow object) {
		// TODO Auto-generated method stub
		
	}

	private void verifyBinding(Binding object) {
		// TODO Auto-generated method stub
		
	}

	private void verifyView(View object) {
		// TODO Auto-generated method stub
		
	}

	private void verifyProgram(Program object) {
		// TODO Auto-generated method stub
		
	}

	private void verifyParameter(AbstractParameter object) {
		// TODO Auto-generated method stub
		
	}

	private void verifyComponentType(ComponentType object) {
		// TODO Auto-generated method stub
		
	}

	private void verifyAccessMethod(AccessMethod object) {
		// TODO Auto-generated method stub
		
	}

	private void verifyTask(Task object) {
		// TODO Auto-generated method stub
		
	}

	private void verifyProcess(Process object) {
		// TODO Auto-generated method stub
		
	}

}
